diff --git a/game/core/src/main/java/net/minecraft/core/entity/MobAge.java b/game/core/src/main/java/net/minecraft/core/entity/MobAge.java
new file mode 100644
index 000000000..831606235
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/entity/MobAge.java
@@ -0,0 +1,121 @@
+package net.minecraft.core.entity;
+
+import com.mojang.nbt.tags.CompoundTag;
+import net.minecraft.core.Global;
+import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public class MobAge
+{
+    public static @NotNull MobAge newRandom(final @NotNull Mob mob, final int maxAge, final int minRandomAge, final int maxRandomAge) {
+        return new MobAge(
+            mob,
+            maxAge,
+            minRandomAge + mob.random.nextInt(maxRandomAge - minRandomAge)
+        );
+    }
+
+    public static final int YEAR_LENGTH_DAYS = 14 * 4;
+
+    private final @NotNull Mob mob;
+    private final int maxAge;
+    private @Nullable AABB boundingBox = null;
+
+    private int ageDays;
+    private long ticksInDay = 0;
+    private long lastTicked = -1;
+
+    public MobAge(final @NotNull Mob mob, final int maxAge, final int age) {
+        this.mob = mob;
+        this.maxAge = maxAge;
+        this.ageDays = age;
+    }
+
+    public int getAge() {
+        return this.ageDays;
+    }
+
+    public int getMaxAge() {
+        return this.maxAge;
+    }
+
+    public void setAge(final int age) {
+        this.ageDays = age;
+    }
+
+    public boolean isAtMaxAge() {
+        return getAge() >= getMaxAge();
+    }
+
+    public float getAgeScale() {
+        // Ranges from 0.6 to 1.2
+        return 0.6f + (((float) getAge() / (float) getMaxAge()) * 0.6f);
+    }
+
+    public void tick(final @NotNull World world) {
+
+        if (this.boundingBox == null) {
+            final @Nullable AABB mobBB = this.mob.getBb();
+            if (mobBB != null) {
+                this.boundingBox = mobBB.copyPermanent();
+            }
+        }
+        if (isAtMaxAge()) {
+            return;
+        }
+
+        final int currentAge = this.getAge();
+
+        // Update mob age
+        if (this.lastTicked == -1) {
+            this.lastTicked = world.getWorldTime();
+        }
+        if (world.getWorldTime() < this.lastTicked) {
+            this.lastTicked = world.getWorldTime();
+        }
+
+        this.ticksInDay += world.getWorldTime() - this.lastTicked;
+        this.lastTicked = world.getWorldTime();
+        while (this.ticksInDay >= Global.DAY_LENGTH_TICKS) {
+            this.ageDays++;
+            this.ticksInDay -= Global.DAY_LENGTH_TICKS;
+        }
+
+        // Update mob attributes
+        if (currentAge < this.maxAge && this.boundingBox != null) {
+            // Update mob size
+            final float size = getAgeScale();
+
+            this.mob.getBb().minX = this.boundingBox.minX * size;
+            this.mob.getBb().minY = this.boundingBox.minY * size;
+            this.mob.getBb().minZ = this.boundingBox.minZ * size;
+            this.mob.getBb().maxX = this.boundingBox.maxX * size;
+            this.mob.getBb().maxY = this.boundingBox.maxY * size;
+            this.mob.getBb().maxZ = this.boundingBox.maxZ * size;
+        }
+    }
+
+    public void writeTag(final @NotNull CompoundTag mobTag) {
+        final @NotNull CompoundTag ageTag = new CompoundTag();
+        ageTag.putInt("age", this.ageDays);
+        ageTag.putLong("ticksInDay", this.ticksInDay);
+        ageTag.putLong("lastTicked", this.lastTicked);
+
+        mobTag.put("age", ageTag);
+    }
+
+    public void readTag(final @NotNull CompoundTag mobTag) {
+        final @Nullable CompoundTag ageTag = mobTag.getCompoundOrDefault("age", null);
+        if (ageTag == null) {
+            this.ageDays = this.maxAge;
+            this.ticksInDay = 0;
+            this.lastTicked = -1;
+        } else {
+            this.ageDays = ageTag.getInteger("age");
+            this.ticksInDay = ageTag.getLong("ticksInDay");
+            this.lastTicked = ageTag.getLong("lastTicked");
+        }
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobChicken.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobChicken.java
index d42023c55..579cc22b0 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobChicken.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobChicken.java
@@ -2,14 +2,17 @@ package net.minecraft.core.entity.animal;
 
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.WeightedRandomLootObject;
+import net.minecraft.core.entity.AgedMob;
+import net.minecraft.core.entity.MobAge;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.tag.ItemTags;
-import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 
-public class MobChicken extends MobAnimal
+public class MobChicken
+    extends MobAnimal
+    implements AgedMob
 {
     public float flap;
     public float flapSpeed;
@@ -17,6 +20,7 @@ public class MobChicken extends MobAnimal
     public float oFlap;
     public float flapping;
     public int eggTimer;
+    private final @NotNull MobAge age;
 
     public MobChicken(World world)
     {
@@ -28,7 +32,14 @@ public class MobChicken extends MobAnimal
         setSize(0.4F, 0.8F);
         eggTimer = random.nextInt(6000) + 6000;
         mobDrops.add(new WeightedRandomLootObject(Items.FEATHER_CHICKEN.getDefaultStack(), 0, 2));
+        this.age = MobAge.newRandom(this, MobAge.YEAR_LENGTH_DAYS * 3, 14, (int) (MobAge.YEAR_LENGTH_DAYS * 2.5f));
     }
+
+    @Override
+    public @NotNull MobAge getMobAge() {
+        return this.age;
+    }
+
     @Override
     public int getMaxHealth(){
         return 4;
@@ -65,23 +76,27 @@ public class MobChicken extends MobAnimal
             dropItem(Items.EGG_CHICKEN.id, 1);
             eggTimer = random.nextInt(6000) + 6000;
         }
+
+        this.getMobAge().tick(world);
     }
 
     @Override
-	protected void causeFallDamage(float distance)
-    {
+    public void readAdditionalSaveData(@NotNull final CompoundTag tag) {
+        super.readAdditionalSaveData(tag);
+
+        this.age.readTag(tag);
     }
 
     @Override
-	public void addAdditionalSaveData(@NotNull CompoundTag tag)
-    {
+    public void addAdditionalSaveData(@NotNull final CompoundTag tag) {
         super.addAdditionalSaveData(tag);
+
+        this.age.writeTag(tag);
     }
 
     @Override
-	public void readAdditionalSaveData(@NotNull CompoundTag tag)
+	protected void causeFallDamage(float distance)
     {
-        super.readAdditionalSaveData(tag);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobCow.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobCow.java
index fc904f58d..7932cf40f 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobCow.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobCow.java
@@ -1,18 +1,22 @@
 package net.minecraft.core.entity.animal;
 
 import net.minecraft.core.WeightedRandomLootObject;
+import net.minecraft.core.entity.AgedMob;
+import net.minecraft.core.entity.MobAge;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemBucketEmpty;
 import net.minecraft.core.item.ItemStack;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.item.tag.ItemTags;
-import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 
-public class MobCow extends MobAnimal
+public class MobCow
+    extends MobAnimal
+    implements AgedMob
 {
+    private final @NotNull MobAge age;
 
     public MobCow(World world)
     {
@@ -20,18 +24,35 @@ public class MobCow extends MobAnimal
         setTextureIdentifier("minecraft", "cow");
         setSize(0.9F, 1.3F);
         mobDrops.add(new WeightedRandomLootObject(Items.LEATHER.getDefaultStack(), 1, 5));
+        this.age = MobAge.newRandom(this, MobAge.YEAR_LENGTH_DAYS * 5, 14, MobAge.YEAR_LENGTH_DAYS * 4);
+    }
+
+    @Override
+    public void onLivingUpdate() {
+        super.onLivingUpdate();
+
+        this.getMobAge().tick(this.world);
+    }
+
+    @Override
+    public @NotNull MobAge getMobAge() {
+        return this.age;
     }
 
     @Override
 	public void addAdditionalSaveData(@NotNull CompoundTag tag)
     {
         super.addAdditionalSaveData(tag);
+
+        this.age.writeTag(tag);
     }
 
     @Override
 	public void readAdditionalSaveData(@NotNull CompoundTag tag)
     {
         super.readAdditionalSaveData(tag);
+
+        this.age.readTag(tag);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java
index 800b23e3a..a4d546a7a 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java
@@ -4,7 +4,9 @@ import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.entity.AgedMob;
 import net.minecraft.core.entity.EntityLightning;
+import net.minecraft.core.entity.MobAge;
 import net.minecraft.core.entity.monster.MobZombiePig;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
@@ -17,10 +19,15 @@ import org.jetbrains.annotations.NotNull;
 import java.util.ArrayList;
 import java.util.List;
 
-public class MobPig extends MobAnimal
+public class MobPig
+    extends MobAnimal
+    implements AgedMob
 {
     public static final int DATA_SADDLE_ID = 16;
 
+    public List<WeightedRandomLootObject> burningMobDrops = new ArrayList<>();
+    private final @NotNull MobAge age;
+
     public MobPig(World world)
     {
         super(world);
@@ -28,6 +35,12 @@ public class MobPig extends MobAnimal
         setSize(0.9F, 0.9F);
         mobDrops.add(new WeightedRandomLootObject(Items.FOOD_PORKCHOP_RAW.getDefaultStack(), 1, 2));
         burningMobDrops.add(new WeightedRandomLootObject(Items.FOOD_PORKCHOP_COOKED.getDefaultStack(), 1, 2));
+        age = MobAge.newRandom(this, MobAge.YEAR_LENGTH_DAYS * 4, 14, MobAge.YEAR_LENGTH_DAYS * 3);
+    }
+
+    @Override
+    public @NotNull MobAge getMobAge() {
+        return this.age;
     }
 
     @Override
@@ -40,6 +53,7 @@ public class MobPig extends MobAnimal
     {
         super.addAdditionalSaveData(tag);
         tag.putBoolean("Saddle", getSaddled());
+        this.age.writeTag(tag);
     }
 
     @Override
@@ -47,6 +61,14 @@ public class MobPig extends MobAnimal
     {
         super.readAdditionalSaveData(tag);
         setSaddled(tag.getBoolean("Saddle"));
+        this.age.readTag(tag);
+    }
+
+    @Override
+    public void onLivingUpdate() {
+        super.onLivingUpdate();
+
+        this.age.tick(this.world);
     }
 
     @Override
@@ -145,5 +167,4 @@ public class MobPig extends MobAnimal
 
         return Blocks.blocksList[itemStack.itemID].hasTag(BlockTags.PIGS_FAVOURITE_BLOCK);
     }
-    public List<WeightedRandomLootObject> burningMobDrops = new ArrayList<>();
 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobSheep.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobSheep.java
index a45ebe472..f4bb60d89 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobSheep.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobSheep.java
@@ -4,7 +4,9 @@ import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.entity.AgedMob;
 import net.minecraft.core.entity.EntityItem;
+import net.minecraft.core.entity.MobAge;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.ItemStack;
@@ -18,18 +20,27 @@ import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
-public class MobSheep extends MobAnimal
+public class MobSheep
+    extends MobAnimal
+    implements AgedMob
 {
     public static final int DATA_WOOL_STATE_ID = 16;
     public static final int MASK_WOOL_COLOR = 0b0000_1111;
     public static final int MASK_SHEARED = 0b0001_0000;
     public static final int DATA_EATING_ID = 17;
 
+    private int growthTimer;
+    public int timeSheepEating;
+    public int prevTimeSheepEating;
+    private final @NotNull MobAge age;
+
     public MobSheep(World world)
     {
         super(world);
         setTextureIdentifier("minecraft", "sheep");
         setSize(0.9F, 1.3F);
+
+        age = MobAge.newRandom(this, MobAge.YEAR_LENGTH_DAYS * 4, 14, MobAge.YEAR_LENGTH_DAYS * 3);
     }
 
     @Override
@@ -45,6 +56,7 @@ public class MobSheep extends MobAnimal
     {
         setFleeceColor(getRandomFleeceColor(random));
     }
+
     @Override
     protected void dropDeathItems()
     {
@@ -54,6 +66,12 @@ public class MobSheep extends MobAnimal
             dropItem(new ItemStack(Blocks.WOOL.id(), 1, getFleeceColor().blockMeta), 0.0F);
         }
     }
+
+    @Override
+    public @NotNull MobAge getMobAge() {
+        return this.age;
+    }
+
     @Override
     public boolean interact(@NotNull Player player)
     {
@@ -105,6 +123,8 @@ public class MobSheep extends MobAnimal
         tag.putBoolean("Sheared", getSheared());
         tag.putByte("Color", (byte)getFleeceColor().blockMeta);
         tag.putShort("GrowthTimer", (short) growthTimer);
+
+        this.age.writeTag(tag);
     }
 
     @Override
@@ -114,6 +134,8 @@ public class MobSheep extends MobAnimal
         setSheared(tag.getBoolean("Sheared"));
         setFleeceColor(DyeColor.colorFromBlockMeta(tag.getByte("Color")));
         setGrowthTimer(tag.getShort("GrowthTimer"));
+
+        this.age.readTag(tag);
     }
 
     @Override
@@ -139,7 +161,6 @@ public class MobSheep extends MobAnimal
 		if (getSheared()) {
 			growthTimer++;
 		}
-
 		
 		if (growthTimer > 400) {
 			int blockX = MathHelper.floor(x);
@@ -188,6 +209,8 @@ public class MobSheep extends MobAnimal
 				}
 			}
 		}
+
+        this.age.tick(this.world);
     }
 
     @Override
@@ -289,9 +312,4 @@ public class MobSheep extends MobAnimal
     public void setGrowthTimer(int growthTimer){
         this.growthTimer = growthTimer;
     }
-
-    private int growthTimer;
-    public int timeSheepEating;
-    public int prevTimeSheepEating;
-
 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
index 39dd8a85e..eeda93f1a 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
@@ -1,9 +1,6 @@
 package net.minecraft.core.entity.animal;
 
-import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityItem;
-import net.minecraft.core.entity.IItemHolding;
-import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.*;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.projectile.ProjectileArrow;
 import net.minecraft.core.item.ItemFood;
@@ -25,7 +22,9 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.*;
 
-public class MobWolf extends MobAnimal implements IItemHolding
+public class MobWolf
+    extends MobAnimal
+    implements IItemHolding, AgedMob
 {
     public static final Map<ArmorMaterial, IArmorItem> ARMOR_MATERIALS = new HashMap<>();
     static {
@@ -53,6 +52,7 @@ public class MobWolf extends MobAnimal implements IItemHolding
     private float timeWolfIsShaking;
     private float prevTimeWolfIsShaking;
     private ItemStack armor = null;
+    private final @NotNull MobAge age;
 
     public MobWolf(World world)
     {
@@ -62,6 +62,7 @@ public class MobWolf extends MobAnimal implements IItemHolding
         setSize(0.8F, 0.8F);
         moveSpeed = 1.1F;
         scoreValue = 500;
+        age = MobAge.newRandom(this, MobAge.YEAR_LENGTH_DAYS * 2, 14, MobAge.YEAR_LENGTH_DAYS * 2);
     }
 
     @Override
@@ -78,6 +79,11 @@ public class MobWolf extends MobAnimal implements IItemHolding
         return super.sendDeathMessage(entityKilledBy) || isWolfTamed();
     }
 
+    @Override
+    public @NotNull MobAge getMobAge() {
+        return this.age;
+    }
+
     @Override
     public void spawnInit() {
         if(random.nextInt(25 /*Used to be 100, but I think having it that high would make it excessively rare*/) == 0){
@@ -183,6 +189,8 @@ public class MobWolf extends MobAnimal implements IItemHolding
             tag.putCompound("Armor", armorTag);
         }
         UUIDHelper.writeToTag(tag, getWolfOwner(), "OwnerUUID");
+
+        age.writeTag(tag);
     }
 
     @Override
@@ -235,6 +243,8 @@ public class MobWolf extends MobAnimal implements IItemHolding
             setWolfOwner(ownerUUID);
             setWolfTamed(true);
         }
+
+        age.readTag(tag);
     }
 
     @Override
@@ -409,6 +419,8 @@ public class MobWolf extends MobAnimal implements IItemHolding
             prevTimeWolfIsShaking = 0.0F;
             world.sendTrackedEntityStatusUpdatePacket(this, (byte)8);
         }
+
+        this.age.tick(this.world);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/net/NetworkManager.java b/game/core/src/main/java/net/minecraft/core/net/NetworkManager.java
index 56421ff3d..7f7cde819 100644
--- a/game/core/src/main/java/net/minecraft/core/net/NetworkManager.java
+++ b/game/core/src/main/java/net/minecraft/core/net/NetworkManager.java
@@ -14,6 +14,7 @@ public class NetworkManager
     private static final Logger LOGGER = LogUtils.getLogger();
 	private final boolean silent;
 	public static int PACKET_DELAY = 100;
+    public static int TIMEOUT_TIME_TICKS = 90 * 20;
 
     public static final Object threadCounterLock = new Object();
     public static int readThreads;
@@ -66,7 +67,7 @@ public class NetworkManager
         packetListener = nethandler;
         try
         {
-            socket.setSoTimeout(30000);
+            socket.setSoTimeout(TIMEOUT_TIME_TICKS * 1000/20);
             socket.setTrafficClass(0x10 | 0x08);
         }
         catch(SocketException socketexception)
@@ -303,7 +304,7 @@ public class NetworkManager
         }
         if(incoming.isEmpty())
         {
-            if(noInputTicks++ == 1200)
+            if(noInputTicks++ == TIMEOUT_TIME_TICKS)
             {
                 networkShutdown("disconnect.timeout", new Object[0]);
             }
diff --git a/game/core/src/main/java/net/minecraft/core/util/phys/AABB.java b/game/core/src/main/java/net/minecraft/core/util/phys/AABB.java
index 55acecb25..3135a9cb7 100644
--- a/game/core/src/main/java/net/minecraft/core/util/phys/AABB.java
+++ b/game/core/src/main/java/net/minecraft/core/util/phys/AABB.java
@@ -287,6 +287,10 @@ public class AABB
         return getTemporaryBB(minX, minY, minZ, maxX, maxY, maxZ);
     }
 
+    public AABB copyPermanent() {
+        return getPermanentBB(minX, minY, minZ, maxX, maxY, maxZ);
+    }
+
 	public HitResult clip(Vec3 start, Vec3 end) {
 		Vec3 vec32 = start.clipX(end, minX);
 		Vec3 vec3d3 = start.clipX(end, maxX);
diff --git a/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java b/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java
index 2e9befd64..b80086510 100644
--- a/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java
+++ b/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java
@@ -99,6 +99,8 @@ public final class SpawnerMobs
                     }
                 }
 
+                if (!world.isChunkLoaded(chunk.x, chunk.z)) continue;
+
                 final int blockX = chunk.x * Chunk.CHUNK_SIZE_X;
                 final int blockZ = chunk.z * Chunk.CHUNK_SIZE_Z;
                 final Biome biome = world.getBlockBiome(blockX, world.getHeightBlocks() - 1, blockZ);
@@ -146,7 +148,7 @@ public final class SpawnerMobs
                         ix += world.rand.nextInt(range) - world.rand.nextInt(range);
                         iy += world.rand.nextInt(2) - world.rand.nextInt(2);
                         iz += world.rand.nextInt(range) - world.rand.nextInt(range);
-                        if (!canCreatureTypeSpawnAtLocation(creatureType, world, ix, iy, iz)) continue;
+                        if (!world.isBlockLoaded(ix, iy, iz) || !canCreatureTypeSpawnAtLocation(creatureType, world, ix, iy, iz)) continue;
 
                         final double dx = ix + 0.5D;
                         final double dy = iy;
diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index 0ba9e0f16..98f67822b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -2093,6 +2093,20 @@ public class World implements WorldSource {
         return null;
     }
 
+    public @Nullable Entity getEntityByID(int id)
+    {
+        for(int i = 0; i < loadedEntityList.size(); i++)
+        {
+            Entity entity = loadedEntityList.get(i);
+            if(entity.id == id)
+            {
+                return entity;
+            }
+        }
+
+        return null;
+    }
+
     public String getNumLoadedEntitiesString()
     {
         return "All: " + loadedEntityList.size();
@@ -2388,7 +2402,7 @@ public class World implements WorldSource {
             }
             
             for (int s = 0; s < Chunk.CHUNK_SECTIONS; s++) {
-                for (int i = 0; i < 10; i++) {
+                for (int i = 0; i < getGameRuleValue(GameRules.RANDOM_TICK_SPEED); i++) {
                     updateLCG = updateLCG * 3 + 0x3c6ef35f;
                     int iRandVal = updateLCG >> 2;
                     int iBlockX = iRandVal & (Chunk.CHUNK_SIZE_X - 1);
diff --git a/game/core/src/main/java/net/minecraft/core/world/config/season/SeasonConfigCycle.java b/game/core/src/main/java/net/minecraft/core/world/config/season/SeasonConfigCycle.java
index a324c291b..903d7c202 100644
--- a/game/core/src/main/java/net/minecraft/core/world/config/season/SeasonConfigCycle.java
+++ b/game/core/src/main/java/net/minecraft/core/world/config/season/SeasonConfigCycle.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.config.season;
 
 import net.minecraft.core.world.season.Season;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.List;
 import java.util.Map;
@@ -9,12 +10,12 @@ public class SeasonConfigCycle
     extends SeasonConfig
 {
     private final List<Season> seasons;
-    private final Map<Season, Integer> seasonLengthMap;
+    private final SeasonMapInternal seasonLengthMap;
 
-    protected SeasonConfigCycle(List<Season> seasons, Map<Season, Integer> seasonLengthMap)
+    protected SeasonConfigCycle(List<Season> seasons, @NotNull Map<Season, Integer> seasonLengthMap)
     {
         this.seasons = seasons;
-        this.seasonLengthMap = seasonLengthMap;
+        this.seasonLengthMap = new SeasonMapInternal(seasonLengthMap);
     }
 
     public List<Season> getSeasons()
@@ -26,4 +27,29 @@ public class SeasonConfigCycle
     {
         return seasonLengthMap.getOrDefault(season, 0);
     }
+
+    private static class SeasonMapInternal { // Exists since seasonLengthMap.getOrDefault is slow for how often it can be called
+        private final Season[] seasons;
+        private final int[] lengths;
+        public SeasonMapInternal(final @NotNull Map<Season, Integer> seasonLengthMap) {
+            this.seasons = new Season[seasonLengthMap.size()];
+            this.lengths = new int[seasonLengthMap.size()];
+
+            int i = 0;
+            for (final Map.Entry<Season, Integer> entry : seasonLengthMap.entrySet()) {
+                this.seasons[i] = entry.getKey();
+                this.lengths[i] = entry.getValue();
+                i++;
+            }
+        }
+
+        public int getOrDefault(final Season season, final int defaultValue) {
+            for (int i = 0; i < this.seasons.length; i++) {
+                if (this.seasons[i].equals(season)) {
+                    return this.lengths[i];
+                }
+            }
+            return defaultValue;
+        }
+    }
 }
diff --git a/game/core/src/main/resources/lang/en_US/gui.lang b/game/core/src/main/resources/lang/en_US/gui.lang
index 07fdc652d..a6e2b5d42 100644
--- a/game/core/src/main/resources/lang/en_US/gui.lang
+++ b/game/core/src/main/resources/lang/en_US/gui.lang
@@ -266,6 +266,7 @@ gui.options.page.debug.button.cheat=Enable Cheats
 gui.options.page.debug.button.crash.soft=Crash Soft
 gui.options.page.debug.button.crash.hard=Crash Hard
 gui.options.page.debug.button.music.skip=Force Ambient Music
+gui.options.page.debug.button.garbage_collect=Run Garbage Collector
 
 gui.options.page.search.title=Search
 
diff --git a/game/core/src/main/resources/lang/en_US/tile.lang b/game/core/src/main/resources/lang/en_US/tile.lang
index dd9f90954..04ef7794a 100644
--- a/game/core/src/main/resources/lang/en_US/tile.lang
+++ b/game/core/src/main/resources/lang/en_US/tile.lang
@@ -838,7 +838,7 @@ tile.sign.post.planks.oak.desc=A free-standing wooden sign.
 tile.sign.wall.planks.oak.name=Wooden Wall Sign
 tile.sign.wall.planks.oak.desc=An wooden sign placed on a wall.
 
-tile.sign.wall.planks.oak.painted.name=Mystery Wooden Chest
+tile.sign.wall.planks.oak.painted.name=Mystery Wooden sign
 tile.sign.wall.planks.oak.painted.desc=How did you get this?!
 tile.sign.wall.planks.oak.painted.black.name=Black Wooden Wall Sign
 tile.sign.wall.planks.oak.painted.black.desc=An wooden sign placed on a wall.
diff --git a/game/server/build.gradle.kts b/game/server/build.gradle.kts
index b527a5cd0..212354ef1 100644
--- a/game/server/build.gradle.kts
+++ b/game/server/build.gradle.kts
@@ -14,15 +14,7 @@ val include: Configuration by configurations.creating
 repositories {
     mavenCentral()
     maven("https://libraries.minecraft.net/")
-
-    ivy {
-        url = uri("https://github.com/Better-than-Adventure")
-        patternLayout {
-            artifact("[organisation]/releases/download/[revision]/brigadier-[revision].jar")
-            m2Compatible
-        }
-        metadataSources { artifact() }
-    }
+    maven("https://jitpack.io")
 }
 
 dependencies {
diff --git a/gradle/libs.versions.toml b/gradle/libs.versions.toml
index 1b50d95b0..afe96605a 100644
--- a/gradle/libs.versions.toml
+++ b/gradle/libs.versions.toml
@@ -5,7 +5,7 @@ lwjgl = "3.3.4"
 [libraries]
 jetbrains-annotations = { module = "org.jetbrains:annotations", version = "24.0.0" }
 gson = { module = "com.google.code.gson:gson", version = "2.10.1" }
-brigadier = { module = "bta-brigadier:bta-brigadier", version = "1.0.1"}
+brigadier = { module = "com.github.Better-than-Adventure:bta-brigadier", version = "1.0.1"}
 slf4j-api = { module = "org.slf4j:slf4j-api", version = "2.0.7" }
 log4j-core = { module = "org.apache.logging.log4j:log4j-core", version.ref = "log4j" }
 log4j-api = { module = "org.apache.logging.log4j:log4j-api", version.ref = "log4j" }
diff --git a/util/datagen/build.gradle.kts b/util/datagen/build.gradle.kts
index b24a50db5..70d2ee8d4 100644
--- a/util/datagen/build.gradle.kts
+++ b/util/datagen/build.gradle.kts
@@ -4,15 +4,8 @@ plugins {
 
 repositories {
     mavenCentral()
+    maven("https://jitpack.io")
     maven("https://libraries.minecraft.net/")
-    ivy {
-        url = uri("https://github.com/Better-than-Adventure")
-        patternLayout {
-            artifact("[organisation]/releases/download/[revision]/brigadier-[revision].jar")
-            m2Compatible
-        }
-        metadataSources { artifact() }
-    }
 }
 
 dependencies {
diff --git a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
index 0b64c0ae7..0482f3a12 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
@@ -1118,8 +1118,8 @@ class WorkbenchGenerator {
         RecipeBuilder.Shapeless(CORE_NAMESPACE)
             .addInput(new ItemStack(Items.DYE, 1, DyeColor.GRAY.itemMeta))
             .addInput(new ItemStack(Items.DYE, 1, DyeColor.GRAY.itemMeta))
-            .addInput(new ItemStack(Items.DYE, 1, DyeColor.BLACK.itemMeta))
-            .create("black_dye_gray_dye_gray_dye_to_light_gray_dye", new ItemStack(Items.DYE, 3, DyeColor.SILVER.itemMeta));
+            .addInput(new ItemStack(Items.DYE, 1, DyeColor.WHITE.itemMeta))
+            .create("white_dye_gray_dye_gray_dye_to_light_gray_dye", new ItemStack(Items.DYE, 3, DyeColor.SILVER.itemMeta));
 
         RecipeBuilder.Shapeless(CORE_NAMESPACE)
             .addInput(new ItemStack(Items.DYE, 1, DyeColor.BLUE.itemMeta))
@@ -1247,20 +1247,6 @@ class WorkbenchGenerator {
                 .create(color.colorID + "_lamp_convert", new ItemStack(Blocks.LAMP_IDLE, 1, color.blockMeta));
         }
 
-        for (DyeColor color : DyeColor.values()) {
-            RecipeBuilder.Shapeless(CORE_NAMESPACE)
-                .addInput(Blocks.LAMP_IDLE, color.blockMeta)
-                .addInput(Blocks.TORCH_REDSTONE_ACTIVE)
-                .create(color.colorID + "_lamp_invert", new ItemStack(Blocks.LAMP_INVERTED_ACTIVE, 1, color.blockMeta));
-        }
-
-        for (DyeColor color : DyeColor.values()) {
-            RecipeBuilder.Shapeless(CORE_NAMESPACE)
-                .addInput("minecraft:lamps_inverted")
-                .addInput(new ItemStack(Items.DYE, 1, color.itemMeta))
-                .create(color.colorID + "_lamp_inverted_convert", new ItemStack(Blocks.LAMP_INVERTED_ACTIVE, 1, color.blockMeta));
-        }
-
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
                 "X",
@@ -1356,7 +1342,6 @@ class WorkbenchGenerator {
         Registries.RECIPES.WORKBENCH.register(String.format(format, "fence_gates_planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:fence_gates_planks"), new ItemStack(Blocks.FENCE_GATE_PLANKS_OAK)));
         Registries.RECIPES.WORKBENCH.register(String.format(format, "trapdoor_planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:trapdoor_planks"), new ItemStack(Blocks.TRAPDOOR_PLANKS_OAK)));
         Registries.RECIPES.WORKBENCH.register(String.format(format, "lamps"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:lamps"), new ItemStack(Blocks.LAMP_IDLE)));
-        Registries.RECIPES.WORKBENCH.register(String.format(format, "lamps_inverted"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:lamps_inverted"), new ItemStack(Blocks.LAMP_INVERTED_IDLE)));
         Registries.RECIPES.WORKBENCH.register(String.format(format, "wools"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:wools"), new ItemStack(Blocks.WOOL)));
         Registries.RECIPES.WORKBENCH.register(String.format(format, "chests"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:chests"), new ItemStack(Blocks.CHEST_PLANKS_OAK)));
     }
diff --git a/util/nbt/build.gradle.kts b/util/nbt/build.gradle.kts
index bf526f429..b73d22a8e 100644
--- a/util/nbt/build.gradle.kts
+++ b/util/nbt/build.gradle.kts
@@ -13,6 +13,7 @@ dependencies {
     testImplementation(platform("org.junit:junit-bom:5.10.0"))
     testImplementation("org.junit.jupiter:junit-jupiter")
 
+    implementation(libs.gson)
     implementation(libs.jetbrains.annotations)
 }
 
